searchData={"items":[{"type":"module","title":"FormBuilderDSL","doc":"Use this module to enable the form DSL.","ref":"FormBuilderDSL.html"},{"type":"module","title":"FormBuilderDSL.Context","doc":"Provides form context and state management.\n\nThis module helps manage form state, including:\n- Field values\n- Validation errors\n- Form submission state\n- Field dependencies","ref":"FormBuilderDSL.Context.html"},{"type":"function","title":"FormBuilderDSL.Context.error_for/2","doc":"Gets the error message for a field.","ref":"FormBuilderDSL.Context.html#error_for/2"},{"type":"function","title":"Parameters - FormBuilderDSL.Context.error_for/2","doc":"- `context` - The form context\n  - `field` - The field key","ref":"FormBuilderDSL.Context.html#error_for/2-parameters"},{"type":"function","title":"Returns - FormBuilderDSL.Context.error_for/2","doc":"- Error message if the field has an error\n  - `nil` if the field has no error","ref":"FormBuilderDSL.Context.html#error_for/2-returns"},{"type":"function","title":"FormBuilderDSL.Context.has_error?/2","doc":"Checks if a field has an error.","ref":"FormBuilderDSL.Context.html#has_error?/2"},{"type":"function","title":"Parameters - FormBuilderDSL.Context.has_error?/2","doc":"- `context` - The form context\n  - `field` - The field key","ref":"FormBuilderDSL.Context.html#has_error?/2-parameters"},{"type":"function","title":"Returns - FormBuilderDSL.Context.has_error?/2","doc":"- `true` if the field has an error\n  - `false` otherwise","ref":"FormBuilderDSL.Context.html#has_error?/2-returns"},{"type":"function","title":"FormBuilderDSL.Context.new/3","doc":"Creates a new form context.","ref":"FormBuilderDSL.Context.html#new/3"},{"type":"function","title":"Parameters - FormBuilderDSL.Context.new/3","doc":"- `form_name` - The name of the form\n  - `fields` - List of field definitions\n  - `opts` - Additional options","ref":"FormBuilderDSL.Context.html#new/3-parameters"},{"type":"function","title":"Options - FormBuilderDSL.Context.new/3","doc":"- `:values` - Initial field values\n  - `:dependencies` - Field dependencies","ref":"FormBuilderDSL.Context.html#new/3-options"},{"type":"type","title":"FormBuilderDSL.Context.t/0","doc":"","ref":"FormBuilderDSL.Context.html#t:t/0"},{"type":"function","title":"FormBuilderDSL.Context.update_value/3","doc":"Updates a field value in the form context.","ref":"FormBuilderDSL.Context.html#update_value/3"},{"type":"function","title":"Parameters - FormBuilderDSL.Context.update_value/3","doc":"- `context` - The form context\n  - `field` - The field key\n  - `value` - The new value","ref":"FormBuilderDSL.Context.html#update_value/3-parameters"},{"type":"function","title":"FormBuilderDSL.Context.valid?/1","doc":"Checks if the form is valid.","ref":"FormBuilderDSL.Context.html#valid?/1"},{"type":"function","title":"Parameters - FormBuilderDSL.Context.valid?/1","doc":"- `context` - The form context","ref":"FormBuilderDSL.Context.html#valid?/1-parameters"},{"type":"function","title":"Returns - FormBuilderDSL.Context.valid?/1","doc":"- `true` if the form has no errors\n  - `false` otherwise","ref":"FormBuilderDSL.Context.html#valid?/1-returns"},{"type":"function","title":"FormBuilderDSL.Context.validate/1","doc":"Validates all fields in the form context.","ref":"FormBuilderDSL.Context.html#validate/1"},{"type":"function","title":"Parameters - FormBuilderDSL.Context.validate/1","doc":"- `context` - The form context","ref":"FormBuilderDSL.Context.html#validate/1-parameters"},{"type":"function","title":"Returns - FormBuilderDSL.Context.validate/1","doc":"- Updated context with validation errors","ref":"FormBuilderDSL.Context.html#validate/1-returns"},{"type":"module","title":"FormBuilderDSL.DSL","doc":"The core DSL module that provides form building capabilities.\n\nThis module provides macros for defining form fields, enums, and form structure.\nIt handles the compilation of form definitions into metadata structures that can\nbe used for rendering, validation, and serialization.","ref":"FormBuilderDSL.DSL.html"},{"type":"macro","title":"FormBuilderDSL.DSL.__before_compile__/1","doc":"Returns the list of fields defined in the form.","ref":"FormBuilderDSL.DSL.html#__before_compile__/1"},{"type":"macro","title":"FormBuilderDSL.DSL.checkbox/2","doc":"","ref":"FormBuilderDSL.DSL.html#checkbox/2"},{"type":"macro","title":"FormBuilderDSL.DSL.color/2","doc":"","ref":"FormBuilderDSL.DSL.html#color/2"},{"type":"macro","title":"FormBuilderDSL.DSL.date/2","doc":"","ref":"FormBuilderDSL.DSL.html#date/2"},{"type":"macro","title":"FormBuilderDSL.DSL.date_time/2","doc":"","ref":"FormBuilderDSL.DSL.html#date_time/2"},{"type":"macro","title":"FormBuilderDSL.DSL.defenum/2","doc":"Defines an enum with the given name and values.","ref":"FormBuilderDSL.DSL.html#defenum/2"},{"type":"macro","title":"Parameters - FormBuilderDSL.DSL.defenum/2","doc":"- `name` - The atom name for the enum\n  - `values` - List of atom values for the enum","ref":"FormBuilderDSL.DSL.html#defenum/2-parameters"},{"type":"macro","title":"Example - FormBuilderDSL.DSL.defenum/2","doc":"defenum :status, [:active, :inactive]\n\nThis will generate:\n  - `status_options/0` - Returns list of string values\n  - `status_labeled_options/0` - Returns list of {label, value} tuples","ref":"FormBuilderDSL.DSL.html#defenum/2-example"},{"type":"macro","title":"FormBuilderDSL.DSL.email/2","doc":"","ref":"FormBuilderDSL.DSL.html#email/2"},{"type":"type","title":"FormBuilderDSL.DSL.enum_name/0","doc":"","ref":"FormBuilderDSL.DSL.html#t:enum_name/0"},{"type":"type","title":"FormBuilderDSL.DSL.enum_values/0","doc":"","ref":"FormBuilderDSL.DSL.html#t:enum_values/0"},{"type":"type","title":"FormBuilderDSL.DSL.field_key/0","doc":"","ref":"FormBuilderDSL.DSL.html#t:field_key/0"},{"type":"type","title":"FormBuilderDSL.DSL.field_opts/0","doc":"","ref":"FormBuilderDSL.DSL.html#t:field_opts/0"},{"type":"type","title":"FormBuilderDSL.DSL.field_type/0","doc":"","ref":"FormBuilderDSL.DSL.html#t:field_type/0"},{"type":"macro","title":"FormBuilderDSL.DSL.file/2","doc":"","ref":"FormBuilderDSL.DSL.html#file/2"},{"type":"macro","title":"FormBuilderDSL.DSL.form/2","doc":"Defines a form with the given name and block of field definitions.","ref":"FormBuilderDSL.DSL.html#form/2"},{"type":"macro","title":"Parameters - FormBuilderDSL.DSL.form/2","doc":"- `name` - The atom name for the form\n  - `block` - A block containing field definitions","ref":"FormBuilderDSL.DSL.html#form/2-parameters"},{"type":"macro","title":"Example - FormBuilderDSL.DSL.form/2","doc":"form :user do\n      text :name\n      email(:email)\n    end","ref":"FormBuilderDSL.DSL.html#form/2-example"},{"type":"macro","title":"FormBuilderDSL.DSL.hidden/2","doc":"","ref":"FormBuilderDSL.DSL.html#hidden/2"},{"type":"function","title":"FormBuilderDSL.DSL.humanize/1","doc":"Converts an atom to a human-readable string.","ref":"FormBuilderDSL.DSL.html#humanize/1"},{"type":"function","title":"Parameters - FormBuilderDSL.DSL.humanize/1","doc":"- `atom` - The atom to convert","ref":"FormBuilderDSL.DSL.html#humanize/1-parameters"},{"type":"function","title":"Returns - FormBuilderDSL.DSL.humanize/1","doc":"- A capitalized string with underscores replaced by spaces","ref":"FormBuilderDSL.DSL.html#humanize/1-returns"},{"type":"function","title":"Example - FormBuilderDSL.DSL.humanize/1","doc":"iex> FormBuilderDSL.DSL.humanize(:first_name)\n    \"First name\"","ref":"FormBuilderDSL.DSL.html#humanize/1-example"},{"type":"macro","title":"FormBuilderDSL.DSL.image/2","doc":"","ref":"FormBuilderDSL.DSL.html#image/2"},{"type":"macro","title":"FormBuilderDSL.DSL.month/2","doc":"","ref":"FormBuilderDSL.DSL.html#month/2"},{"type":"macro","title":"FormBuilderDSL.DSL.multi_select/2","doc":"","ref":"FormBuilderDSL.DSL.html#multi_select/2"},{"type":"macro","title":"FormBuilderDSL.DSL.number/2","doc":"","ref":"FormBuilderDSL.DSL.html#number/2"},{"type":"macro","title":"FormBuilderDSL.DSL.password/2","doc":"","ref":"FormBuilderDSL.DSL.html#password/2"},{"type":"macro","title":"FormBuilderDSL.DSL.radio/2","doc":"","ref":"FormBuilderDSL.DSL.html#radio/2"},{"type":"macro","title":"FormBuilderDSL.DSL.range/2","doc":"","ref":"FormBuilderDSL.DSL.html#range/2"},{"type":"macro","title":"FormBuilderDSL.DSL.search/2","doc":"","ref":"FormBuilderDSL.DSL.html#search/2"},{"type":"macro","title":"FormBuilderDSL.DSL.select/2","doc":"","ref":"FormBuilderDSL.DSL.html#select/2"},{"type":"macro","title":"FormBuilderDSL.DSL.switch/2","doc":"","ref":"FormBuilderDSL.DSL.html#switch/2"},{"type":"macro","title":"FormBuilderDSL.DSL.tel/2","doc":"","ref":"FormBuilderDSL.DSL.html#tel/2"},{"type":"macro","title":"FormBuilderDSL.DSL.text/2","doc":"Defines a text input field.","ref":"FormBuilderDSL.DSL.html#text/2"},{"type":"macro","title":"Parameters - FormBuilderDSL.DSL.text/2","doc":"- `key` - The atom key for the field\n  - `opts` - Optional field attributes","ref":"FormBuilderDSL.DSL.html#text/2-parameters"},{"type":"macro","title":"Options - FormBuilderDSL.DSL.text/2","doc":"- `:label` - Custom label for the field\n  - `:required` - Whether the field is required\n  - `:placeholder` - Placeholder text\n  - `:default` - Default value\n  - `:validations` - List of validation rules\n  - `:disabled` - Whether the field is disabled","ref":"FormBuilderDSL.DSL.html#text/2-options"},{"type":"macro","title":"FormBuilderDSL.DSL.time/2","doc":"","ref":"FormBuilderDSL.DSL.html#time/2"},{"type":"macro","title":"FormBuilderDSL.DSL.url/2","doc":"","ref":"FormBuilderDSL.DSL.html#url/2"},{"type":"macro","title":"FormBuilderDSL.DSL.week/2","doc":"","ref":"FormBuilderDSL.DSL.html#week/2"},{"type":"module","title":"FormBuilderDSL.EnumRegistry","doc":"Runtime-safe enum registry and utilities using ETS.\n\nThis module provides a way to register and manage enums in your application, ensuring they can be\nsafely accessed at both compile-time and runtime. It uses ETS (Erlang Term Storage) for efficient\nstorage and retrieval of enum values.","ref":"FormBuilderDSL.EnumRegistry.html"},{"type":"module","title":"Usage - FormBuilderDSL.EnumRegistry","doc":"First, ensure the enum registry is started in your application's supervision tree:\n\n```elixir\n# In your application.ex\nchildren = [\n  FormBuilderDSL.EnumRegistry\n]\n```\n\nThen you can register and use enums in your forms:\n\n```elixir\ndefmodule MyForm do\n  use FormBuilderDSL\n\n  # Register an enum\n  defenum :status, [:active, :inactive, :pending]\n\n  form :user do\n    # Use the enum in a select field\n    select :status, options: status_labeled_options()\n  end\nend\n```","ref":"FormBuilderDSL.EnumRegistry.html#module-usage"},{"type":"module","title":"Features - FormBuilderDSL.EnumRegistry","doc":"- Runtime-safe enum registration and retrieval\n- Support for both simple string options and labeled options (for form selects)\n- ETS-based storage for efficient access\n- Automatic table creation and management","ref":"FormBuilderDSL.EnumRegistry.html#module-features"},{"type":"function","title":"FormBuilderDSL.EnumRegistry.child_spec/1","doc":"","ref":"FormBuilderDSL.EnumRegistry.html#child_spec/1"},{"type":"type","title":"FormBuilderDSL.EnumRegistry.enum_list/0","doc":"","ref":"FormBuilderDSL.EnumRegistry.html#t:enum_list/0"},{"type":"type","title":"FormBuilderDSL.EnumRegistry.enum_name/0","doc":"","ref":"FormBuilderDSL.EnumRegistry.html#t:enum_name/0"},{"type":"type","title":"FormBuilderDSL.EnumRegistry.enum_value/0","doc":"","ref":"FormBuilderDSL.EnumRegistry.html#t:enum_value/0"},{"type":"function","title":"FormBuilderDSL.EnumRegistry.labeled_options/1","doc":"Returns enum values as `{label, value}` tuples — used for form select fields.","ref":"FormBuilderDSL.EnumRegistry.html#labeled_options/1"},{"type":"function","title":"Parameters - FormBuilderDSL.EnumRegistry.labeled_options/1","doc":"- `name` - The atom name of the registered enum","ref":"FormBuilderDSL.EnumRegistry.html#labeled_options/1-parameters"},{"type":"function","title":"Returns - FormBuilderDSL.EnumRegistry.labeled_options/1","doc":"- List of `{label, value}` tuples where:\n    - `label` is a humanized version of the value (e.g., \"Active\" for `:active`)\n    - `value` is the string representation of the enum value","ref":"FormBuilderDSL.EnumRegistry.html#labeled_options/1-returns"},{"type":"function","title":"Examples - FormBuilderDSL.EnumRegistry.labeled_options/1","doc":"iex> FormBuilderDSL.EnumRegistry.register(:status, [:active, :inactive])\n    :ok\n    iex> FormBuilderDSL.EnumRegistry.labeled_options(:status)\n    [{\"Active\", \"active\"}, {\"Inactive\", \"inactive\"}]","ref":"FormBuilderDSL.EnumRegistry.html#labeled_options/1-examples"},{"type":"function","title":"FormBuilderDSL.EnumRegistry.options/1","doc":"Returns the enum list as a list of strings.","ref":"FormBuilderDSL.EnumRegistry.html#options/1"},{"type":"function","title":"Parameters - FormBuilderDSL.EnumRegistry.options/1","doc":"- `name` - The atom name of the registered enum","ref":"FormBuilderDSL.EnumRegistry.html#options/1-parameters"},{"type":"function","title":"Returns - FormBuilderDSL.EnumRegistry.options/1","doc":"- List of strings representing the enum values","ref":"FormBuilderDSL.EnumRegistry.html#options/1-returns"},{"type":"function","title":"Examples - FormBuilderDSL.EnumRegistry.options/1","doc":"iex> FormBuilderDSL.EnumRegistry.register(:status, [:active, :inactive])\n    :ok\n    iex> FormBuilderDSL.EnumRegistry.options(:status)\n    [\"active\", \"inactive\"]","ref":"FormBuilderDSL.EnumRegistry.html#options/1-examples"},{"type":"function","title":"FormBuilderDSL.EnumRegistry.register/2","doc":"Registers an enum under a given name (replaces previous if exists).","ref":"FormBuilderDSL.EnumRegistry.html#register/2"},{"type":"function","title":"Parameters - FormBuilderDSL.EnumRegistry.register/2","doc":"- `name` - The atom name for the enum (e.g., `:status`)\n  - `values` - List of atom values for the enum (e.g., `[:active, :inactive]`)","ref":"FormBuilderDSL.EnumRegistry.html#register/2-parameters"},{"type":"function","title":"Examples - FormBuilderDSL.EnumRegistry.register/2","doc":"iex> FormBuilderDSL.EnumRegistry.register(:status, [:active, :inactive])\n    :ok\n    iex> FormBuilderDSL.EnumRegistry.options(:status)\n    [\"active\", \"inactive\"]","ref":"FormBuilderDSL.EnumRegistry.html#register/2-examples"},{"type":"function","title":"FormBuilderDSL.EnumRegistry.start_link/1","doc":"Starts the ETS table if not already started. Works in supervision trees.","ref":"FormBuilderDSL.EnumRegistry.html#start_link/1"},{"type":"function","title":"Examples - FormBuilderDSL.EnumRegistry.start_link/1","doc":"iex> FormBuilderDSL.EnumRegistry.start_link([])\n    {:ok, #PID<0.123.0>}","ref":"FormBuilderDSL.EnumRegistry.html#start_link/1-examples"},{"type":"module","title":"FormBuilderDSL.Field","doc":"Metadata struct representing one form input field.\nUsed for rendering, validation, introspection, and serialization.","ref":"FormBuilderDSL.Field.html"},{"type":"module","title":"FormBuilderDSL.FieldType","doc":"Field type metadata to describe rendering logic and behavior per type.","ref":"FormBuilderDSL.FieldType.html"},{"type":"function","title":"FormBuilderDSL.FieldType.all/0","doc":"Returns all supported types","ref":"FormBuilderDSL.FieldType.html#all/0"},{"type":"function","title":"FormBuilderDSL.FieldType.get_config/1","doc":"Get metadata associated with a field type","ref":"FormBuilderDSL.FieldType.html#get_config/1"},{"type":"type","title":"FormBuilderDSL.FieldType.t/0","doc":"","ref":"FormBuilderDSL.FieldType.html#t:t/0"},{"type":"function","title":"FormBuilderDSL.FieldType.valid?/1","doc":"Returns true if the type is supported","ref":"FormBuilderDSL.FieldType.html#valid?/1"},{"type":"module","title":"FormBuilderDSL.Validations","doc":"Provides validation helpers for form fields.\n\nThis module contains functions for validating form field values based on\nthe validation rules defined in the form.","ref":"FormBuilderDSL.Validations.html"},{"type":"function","title":"FormBuilderDSL.Validations.validate/2","doc":"Validates a field value against its validation rules.","ref":"FormBuilderDSL.Validations.html#validate/2"},{"type":"function","title":"Parameters - FormBuilderDSL.Validations.validate/2","doc":"- `value` - The value to validate\n  - `validations` - List of validation rules","ref":"FormBuilderDSL.Validations.html#validate/2-parameters"},{"type":"function","title":"Returns - FormBuilderDSL.Validations.validate/2","doc":"- `:ok` if validation passes\n  - `{:error, reason}` if validation fails","ref":"FormBuilderDSL.Validations.html#validate/2-returns"},{"type":"function","title":"Validation Rules - FormBuilderDSL.Validations.validate/2","doc":"- `:required` - Value must be present\n  - `:min_length` - String must be at least this long\n  - `:max_length` - String must be at most this long\n  - `:min` - Number must be at least this value\n  - `:max` - Number must be at most this value\n  - `:format` - Value must match the given format\n  - `:in` - Value must be in the given list","ref":"FormBuilderDSL.Validations.html#validate/2-validation-rules"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}